package com.idea.invoice.controller;

import com.github.pagehelper.PageInfo;
import com.idea.customerManagement.model.IntentionalDeposit;
import com.idea.invoice.dto.ReceiptManageDto;
import com.idea.invoice.model.ReceiptManage;
import com.idea.invoice.service.ReceiptManageService;
import com.rockstar.common.base.BaseController;
import com.rockstar.frame.model.extend.TableSplitResult;
import com.rockstar.frame.model.extend.Tablepar;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletResponse;

@Controller
@RequestMapping(value = "ReceiptManageController")
@Api(value="票据管理")
public class ReceiptManageController extends BaseController {

    @Autowired
    private ReceiptManageService modelService;

    @PostMapping(value = "listByModel",produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object listByModel(Tablepar tablepar, ReceiptManageDto model){
        PageInfo page = modelService.listByModel(tablepar, model);
        return new TableSplitResult<ReceiptManageDto>(page.getPageNum(),page.getTotal(),page.getList());
    }




    /**
     * 意向金收据下载
     * @param id
     * @param response
     */
    @GetMapping(value = "downLoadReceipt",produces = {"application/json;charset=UTF-8"})
    public void downLoadReceipt(String id, HttpServletResponse response) {
        modelService.downLoadReceipt(id,response);
    }





}
