package com.idea.pro.controller;

import com.google.code.kaptcha.Constants;
import com.rockstar.common.log.Log;
import com.rockstar.frame.controller.HomeController;
import com.rockstar.shiro.authc.EasyTypeToken;
import com.rockstar.util.Constant;
import com.rockstar.util.StringUtils;
import io.swagger.annotations.Api;
import org.apache.shiro.SecurityUtils;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;
import java.util.UUID;

/**
 * Created by pengyq on 2020.
 */
@Controller
@RequestMapping(value = "pub")
@Api(value="公共控制类")
public class PubController extends HomeController {

    @Log(title = "免密登录")
    @PostMapping("/loginSecret")
    @ResponseBody
    public Map<String, Object> loginByKey(String userName, HttpServletRequest request) {

        try {
            Constant.getInstance().setUserType(Constant.USER_TYPE_MANAGER);
            String code = UUID.randomUUID().toString();
            request.getSession().setAttribute(Constants.KAPTCHA_SESSION_KEY, code);
            Map<String, Object> view = loginView(userName, null,code,null,false,request, true, EasyTypeToken.LoginType.NOPASSWD);
            view.put(Constant.VIEW_KEY_USER_TYPE, Constant.USER_TYPE_MANAGER);
            view.put(Constant.VIEW_KEY_TOKEN, "admin-token");

            SecurityUtils.getSubject().getSession().setTimeout(3600000L);
            return view;
        } catch (Exception e) {
            String msg = "用户或密码错误";
            if (StringUtils.isNotEmpty(e.getMessage())) {
                msg = e.getMessage();
            }
            return error(msg);
        }
    }



}
